module RtsFiles where

import Data.ByteString.Unsafe
import Data.ByteString
import System.IO.Unsafe

{-# NOINLINE theData #-}
theData :: ByteString
theData = unsafePerformIO $ unsafePackAddress "\
 \#ifdef JHC_RTS_INCLUDE\n\
 \#include \"HsFFI.h\"\n\
 \#include \"wsize.h\"\n\
 \#include \"jhc_rts_header.h\"\n\
 \#include \"jhc_jgc.h\"\n\
 \#include \"debug.c\"\n\
 \#include \"jhc_rts_alloc.c\"\n\
 \#include \"jhc_rts.c\"\n\
 \#include \"profile.c\"\n\
 \#include \"jhc_rts2.c\"\n\
 \#include \"bitarray.h\"\n\
 \#include \"slub.c\"\n\
 \#include \"jhc_jgc.c\"\n\
 \#include \"lib_cbits.c\"\n\
 \#else\n\
 \/* src/data/HsFFI.h */\n\
 \/* HsFFI.h for jhc */\n\
 \\n\
 \#ifndef _JHC_HSFFI_H\n\
 \#define _JHC_HSFFI_H\n\
 \\n\
 \#include <stdint.h>\n\
 \#include <stdbool.h>\n\
 \#include <stddef.h>\n\
 \\n\
 \\n\
 \typedef int32_t HsInt;\n\
 \typedef int8_t  HsInt8;\n\
 \typedef int16_t HsInt16;\n\
 \typedef int32_t HsInt32;\n\
 \typedef int64_t HsInt64;\n\
 \\n\
 \typedef uint32_t HsWord;\n\
 \typedef uint8_t  HsWord8;\n\
 \typedef uint16_t HsWord16;\n\
 \typedef uint32_t HsWord32;\n\
 \typedef uint64_t HsWord64;\n\
 \\n\
 \typedef wchar_t HsChar;\n\
 \typedef bool HsBool;\n\
 \\n\
 \typedef double HsDouble;\n\
 \typedef float HsFloat;\n\
 \\n\
 \typedef void *HsPtr;\n\
 \typedef void (*HsFunPtr)(void);\n\
 \typedef void *HsStablePtr;\n\
 \\n\
 \#define HS_BOOL_FALSE 0\n\
 \#define HS_BOOL_TRUE 1\n\
 \\n\
 \void hs_init (int *argc, char **argv[]);\n\
 \void hs_exit (void);\n\
 \void hs_set_argv(int argc, char *argv[]);\n\
 \void hs_perform_gc(void);\n\
 \void hs_free_stable_ptr(HsStablePtr sp);\n\
 \void hs_free_fun_ptr(HsFunPtr fp);\n\
 \\n\
 \#endif\n\
 \/* src/rts/wsize.h */\n\
 \#ifndef WSIZE_H\n\
 \#define WSIZE_H\n\
 \\n\
 \/*\n\
 \ * wsize.h\n\
 \ * define appropriate __WORDSIZE and __BYTE_ORDER macros\n\
 \ *\n\
 \ * always use operating systems headers rather than checking for architectures\n\
 \ * when possible. if adding new cases. Checking the CPU type should be a last\n\
 \ * resort.\n\
 \ *\n\
 \ */\n\
 \\n\
 \#include <limits.h>\n\
 \\n\
 \#ifdef __linux__\n\
 \#include<endian.h>\n\
 \#endif\n\
 \\n\
 \#ifndef __LITTLE_ENDIAN\n\
 \#define\x0009\&__LITTLE_ENDIAN\x0009\&1234\n\
 \#endif\n\
 \#ifndef __BIG_ENDIAN\n\
 \#define\x0009\&__BIG_ENDIAN\x0009\&4321\n\
 \#endif\n\
 \#ifndef __PDP_ENDIAN\n\
 \#define\x0009\&__PDP_ENDIAN\x0009\&3412\n\
 \#endif\n\
 \\n\
 \#ifndef __BYTE_ORDER\n\
 \#ifdef _BIG_ENDIAN\n\
 \#define __BYTE_ORDER __BIG_ENDIAN\n\
 \#elif defined(__BIG_ENDIAN__)\n\
 \#define __BYTE_ORDER __BIG_ENDIAN\n\
 \#elif defined(_LITTLE_ENDIAN)\n\
 \#define __BYTE_ORDER __LITTLE_ENDIAN\n\
 \#elif defined(__LITTLE_ENDIAN__)\n\
 \#define __BYTE_ORDER __LITTLE_ENDIAN\n\
 \#elif defined(__i386__)\n\
 \#define __BYTE_ORDER __LITTLE_ENDIAN\n\
 \#else\n\
 \#error Could not determine Byte Order\n\
 \#endif\n\
 \#endif\n\
 \\n\
 \#ifndef __WORDSIZE\n\
 \#ifdef __SIZEOF_POINTER__\n\
 \#define __WORDSIZE (CHAR_BIT*__SIZEOF_POINTER__)\n\
 \#elif defined(__i386__)\n\
 \#define __WORDSIZE 32\n\
 \#elif defined(__x86_64__)\n\
 \#define __WORDSIZE 64\n\
 \#else\n\
 \#error Could not determine bitsize\n\
 \#endif\n\
 \#endif\n\
 \\n\
 \\n\
 \#ifdef TEST_WSIZE\n\
 \#include <stdio.h>\n\
 \int\n\
 \main(int argc, char *argv[])\n\
 \{\n\
 \    printf(\"__WORDSIZE:   %i\\n\", __WORDSIZE);\n\
 \    printf(\"__BYTE_ORDER: %i\\n\", __BYTE_ORDER);\n\
 \    return 0;\n\
 \}\n\
 \#endif\n\
 \\n\
 \#endif\n\
 \/* src/rts/jhc_rts_header.h */\n\
 \#include <assert.h>\n\
 \#include <errno.h>\n\
 \#include <float.h>\n\
 \#include <limits.h>\n\
 \#include <locale.h>\n\
 \#include <math.h>\n\
 \#include <stdio.h>\n\
 \#include <stdlib.h>\n\
 \#include <string.h>\n\
 \#include <time.h>\n\
 \#include <unistd.h>\n\
 \#include <wchar.h>\n\
 \#include <setjmp.h>\n\
 \#ifndef __WIN32__\n\
 \#include <sys/select.h>\n\
 \#include <sys/times.h>\n\
 \#include <sys/types.h>\n\
 \#include <sys/param.h>\n\
 \#include <sys/utsname.h>\n\
 \#else\n\
 \#include <malloc.h>\n\
 \#endif\n\
 \\n\
 \// #define our options\n\
 \\n\
 \#define _JHC_GC_NONE   0\n\
 \#define _JHC_GC_JGC    1\n\
 \#define _JHC_GC_BOEHM  2\n\
 \#define _JHC_GC_REGION 3\n\
 \\n\
 \#ifndef _JHC_GC\n\
 \#define _JHC_GC _JHC_GC_NONE\n\
 \#endif\n\
 \\n\
 \#ifndef _JHC_PROFILE\n\
 \#define _JHC_PROFILE 0\n\
 \#endif\n\
 \\n\
 \#ifndef _JHC_DEBUG\n\
 \#ifdef NDEBUG\n\
 \#define _JHC_DEBUG 0\n\
 \#else\n\
 \#define _JHC_DEBUG 1\n\
 \#endif\n\
 \#endif\n\
 \\n\
 \#ifndef JHC_VALGRIND\n\
 \#define JHC_VALGRIND 0\n\
 \#endif\n\
 \\n\
 \#ifndef JHC_MEM_ANNOTATE\n\
 \#define JHC_MEM_ANNOTATE 0\n\
 \#endif\n\
 \\n\
 \#ifndef _JHC_STANDALONE\n\
 \#define _JHC_STANDALONE 1\n\
 \#endif\n\
 \\n\
 \#ifndef JHC_STATUS\n\
 \#define JHC_STATUS 0\n\
 \#endif\n\
 \\n\
 \// GNU attributes\n\
 \#ifdef __GNUC__\n\
 \#  define __predict_true(exp)     __builtin_expect(!!(exp), 1)\n\
 \#  define __predict_false(exp)    __builtin_expect(!!(exp), 0)\n\
 \#else\n\
 \#  define __predict_true(exp)     (exp)\n\
 \#  define __predict_false(exp)    (exp)\n\
 \#endif\n\
 \\n\
 \#ifdef __GNUC__\n\
 \#define A_ALIGNED  __attribute__ ((aligned))\n\
 \#define A_CONST    __attribute__ ((const))\n\
 \#define A_MALLOC   __attribute__ ((malloc))\n\
 \#define A_MAYALIAS __attribute__ ((__may_alias__))\n\
 \#define A_NORETURN __attribute__ ((noreturn))\n\
 \#define A_PURE     __attribute__ ((pure))\n\
 \#define A_UNUSED   __attribute__ ((unused))\n\
 \#ifdef __i386__\n\
 \#define A_REGPARM __attribute__ ((fastcall))\n\
 \#else\n\
 \#define A_REGPARM\n\
 \#endif\n\
 \#define A_STD    A_REGPARM\n\
 \\n\
 \#else\n\
 \#define A_ALIGNED\n\
 \#define A_CONST\n\
 \#define A_MALLOC\n\
 \#define A_MAYALIAS\n\
 \#define A_NORETURN\n\
 \#define A_PURE\n\
 \#define A_UNUSED\n\
 \#define A_STD\n\
 \#endif\n\
 \\n\
 \// these should be enabled with newer versions of gcc\n\
 \#define A_HOT\n\
 \#define A_COLD\n\
 \#define A_FALIGNED\n\
 \\n\
 \#define M_ALIGN(a,n) ((n) - 1 + ((a) - ((n) - 1) % (a)))\n\
 \\n\
 \#ifdef __WIN32__\n\
 \#define JHC_isWindows   1\n\
 \#define JHC_isBigEndian 0\n\
 \#else\n\
 \#define JHC_isWindows 0\n\
 \#define JHC_isBigEndian (__BYTE_ORDER == __BIG_ENDIAN)\n\
 \#endif\n\
 \\n\
 \#define JHC_isPosix (!JHC_isWindows)\n\
 \\n\
 \static void _amain(void);\n\
 \\n\
 \static void jhc_alloc_init(void);\n\
 \static void jhc_alloc_fini(void);\n\
 \static void jhc_alloc_print_stats(void);\n\
 \static void jhc_print_profile(void);\n\
 \\n\
 \static int jhc_argc;\n\
 \static char **jhc_argv;\n\
 \static char *jhc_progname;\n\
 \\n\
 \#if JHC_STATUS > 1\n\
 \#define debugf(...) fprintf(stderr,__VA_ARGS__)\n\
 \#else\n\
 \#define debugf(...) do { } while (0)\n\
 \#endif\n\
 \/* src/rts/jhc_jgc.h */\n\
 \#if _JHC_GC == _JHC_GC_JGC\n\
 \\n\
 \#ifdef JHC_JGC_STACK\n\
 \struct frame;\n\
 \typedef struct frame *gc_t;\n\
 \#else\n\
 \typedef void* *gc_t;\n\
 \static gc_t gc_stack_base;\n\
 \#endif\n\
 \\n\
 \static gc_t saved_gc;\n\
 \\n\
 \#define GC_BASE sizeof(void *)\n\
 \\n\
 \#define TO_BLOCKS(x) ((x) <= GC_BASE ? 1 : (((x) - 1)/GC_BASE) + 1)\n\
 \\n\
 \struct s_cache;\n\
 \static void gc_perform_gc(gc_t gc);\n\
 \static void *gc_alloc(gc_t gc,struct s_cache **sc, unsigned count, unsigned nptrs);\n\
 \\n\
 \#endif\n\
 \/* src/rts/debug.c */\n\
 \#if JHC_VALGRIND\n\
 \#include <valgrind/valgrind.h>\n\
 \#include <valgrind/memcheck.h>\n\
 \#else\n\
 \#define VALGRIND_MAKE_MEM_UNDEFINED(x,y) \\\n\
 \    do { } while (0)\n\
 \#define VALGRIND_MAKE_MEM_DEFINED(x,y) \\\n\
 \    do { } while (0)\n\
 \#define VALGRIND_MAKE_MEM_NOACCESS(x,y) \\\n\
 \    do { } while (0)\n\
 \#define VALGRIND_PRINTF(...) \\\n\
 \    do { } while (0)\n\
 \#endif\n\
 \\n\
 \#if JHC_MEM_ANNOTATE && _JHC_GC == _JHC_GC_JGC\n\
 \#include <Judy.h>\n\
 \\n\
 \static Pvoid_t mem_annotate = NULL;\n\
 \\n\
 \#define XSTR(x) #x\n\
 \#define STR(x) XSTR(x)\n\
 \#define gc_alloc(gc,sc,c,nptrs) \\\n\
 \    gc_alloc_annot(gc,sc,c,nptrs,(__FILE__ \":\" STR(__LINE__)))\n\
 \\n\
 \\n\
 \A_UNUSED static void *\n\
 \gc_alloc_annot(gc_t gc,struct s_cache **sc, unsigned count, unsigned nptrs, char *str)\n\
 \{\n\
 \        void *ret = (gc_alloc)(gc,sc,count,nptrs);\n\
 \        PWord_t pval;\n\
 \        JLI(pval,mem_annotate,(Word_t)ret);\n\
 \        *pval = (Word_t)str;\n\
 \        return ret;\n\
 \}\n\
 \\n\
 \char *\n\
 \gc_lookup(void *ptr)\n\
 \{\n\
 \        PWord_t pval;\n\
 \        JLG(pval,mem_annotate,(Word_t)ptr & ~(Word_t)3);\n\
 \        return pval ? (char *)*pval : \"(none)\";\n\
 \}\n\
 \\n\
 \\n\
 \#endif\n\
 \/* src/rts/jhc_rts_alloc.c */\n\
 \#define jhc_malloc_whnf jhc_malloc\n\
 \#define jhc_malloc_suspension jhc_malloc\n\
 \#define jhc_malloc_atomic jhc_malloc\n\
 \#define jhc_malloc_atomic_whnf jhc_malloc_atomic\n\
 \#define jhc_malloc_sanity(p,t) (1)\n\
 \#define _JHC_GC_CONTEXT 0\n\
 \\n\
 \#ifdef JHC_ALLOC_NEEDS_STUBS\n\
 \void hs_perform_gc(void) {}\n\
 \void hs_free_stable_ptr(HsStablePtr sp) {}\n\
 \void hs_free_fun_ptr(HsFunPtr fp) {}\n\
 \#endif\n\
 \\n\
 \#if _JHC_PROFILE\n\
 \\n\
 \#define BUCKETS 7\n\
 \\n\
 \static unsigned alloced[BUCKETS];\n\
 \static unsigned alloced_atomic[BUCKETS];\n\
 \\n\
 \static void\n\
 \alloc_count(int n,int atomic)\n\
 \{\n\
 \        n = n ? ((n - 1)/sizeof(void *)) + 1 : 0;\n\
 \        n = n > BUCKETS - 1 ? BUCKETS - 1 : n;\n\
 \        (atomic ? alloced_atomic : alloced)[n]++;\n\
 \}\n\
 \\n\
 \\n\
 \static void\n\
 \print_alloc_size_stats(void) {\n\
 \        char fmt[] = \"%10s %10s %10s %10s %10s\\n\";\n\
 \        char fmt2[] = \"%10u %10u %10u %10u %10u\\n\";\n\
 \        fprintf(stderr,fmt,\"Size\",\"Normal\",\"Atomic\",\"Total\",\"Accum\");\n\
 \        fprintf(stderr,fmt,\"----\",\"------\",\"------\",\"-----\",\"-----\");\n\
 \        unsigned accum = 0;\n\
 \        for(int i = 0; i < BUCKETS; i++) {\n\
 \                accum += alloced[i] + alloced_atomic[i];\n\
 \                fprintf(stderr,fmt2,i,alloced[i],alloced_atomic[i],alloced_atomic[i] + alloced[i], accum);\n\
 \        }\n\
 \}\n\
 \\n\
 \\n\
 \#else\n\
 \\n\
 \#define alloc_count(x,y)\n\
 \#define print_alloc_size_stats()\n\
 \\n\
 \#endif\n\
 \\n\
 \#if _JHC_GC == _JHC_GC_BOEHM\n\
 \\n\
 \#include <gc/gc.h>\n\
 \\n\
 \#define jhc_malloc GC_malloc\n\
 \#undef  jhc_malloc_atomic\n\
 \#define jhc_malloc_atomic GC_malloc_atomic\n\
 \#define jhc_free GC_free\n\
 \\n\
 \static void jhc_malloc_init(void) { GC_INIT(); }\n\
 \static void jhc_malloc_fini(void) {  }\n\
 \static void jhc_alloc_print_stats(void) { GC_dump(); }\n\
 \\n\
 \\n\
 \#elif _JHC_GC == _JHC_GC_NONE\n\
 \\n\
 \// memory allocated in 1MB chunks.\n\
 \#define JHC_MEM_CHUNK_SIZE (1 << 20)\n\
 \\n\
 \static char initial_chunk[JHC_MEM_CHUNK_SIZE];\n\
 \\n\
 \static void *jhc_current_chunk = initial_chunk;\n\
 \static unsigned mem_chunks,mem_offset;\n\
 \\n\
 \\n\
 \static void jhc_alloc_init(void) {}\n\
 \static void jhc_alloc_fini(void) {}\n\
 \\n\
 \static void\n\
 \jhc_alloc_print_stats(void) {\n\
 \        fprintf(stderr, \"Memory Allocated: %u bytes\\n\", (JHC_MEM_CHUNK_SIZE*(mem_chunks)) + mem_offset);\n\
 \        print_alloc_size_stats();\n\
 \}\n\
 \\n\
 \static void\n\
 \jhc_malloc_grow(void) {\n\
 \        void *c = malloc(JHC_MEM_CHUNK_SIZE);\n\
 \        if(!c) {\n\
 \                fputs(\"Out of memory!\\n\",stderr);\n\
 \                abort();\n\
 \        }\n\
 \        mem_chunks++;\n\
 \        jhc_current_chunk = c;\n\
 \        mem_offset = 0;\n\
 \}\n\
 \\n\
 \static inline void * A_MALLOC\n\
 \jhc_malloc_basic(size_t n) {\n\
 \        n = M_ALIGN(sizeof(void *),n);\n\
 \        if (n > (JHC_MEM_CHUNK_SIZE - mem_offset))\n\
 \                jhc_malloc_grow();\n\
 \        void *ret = jhc_current_chunk + mem_offset;\n\
 \        mem_offset += n;\n\
 \        return ret;\n\
 \}\n\
 \\n\
 \\n\
 \#if _JHC_DEBUG\n\
 \\n\
 \#define jhc_malloc(n) jhc_malloc_debug(n,__LINE__,0)\n\
 \#undef jhc_malloc_atomic\n\
 \#define jhc_malloc_atomic(n) jhc_malloc_debug(n,__LINE__,1)\n\
 \\n\
 \static void * A_MALLOC\n\
 \jhc_malloc_debug(size_t n,int line,int atomic) {\n\
 \        alloc_count(n,atomic);\n\
 \        void *ret = jhc_malloc_basic(n + sizeof(uintptr_t));\n\
 \        *((uintptr_t *)ret) = line;\n\
 \        return ret + sizeof(uintptr_t);\n\
 \}\n\
 \\n\
 \#else\n\
 \\n\
 \static inline void * A_MALLOC\n\
 \jhc_malloc(size_t n) {\n\
 \        alloc_count(n,0);\n\
 \        return jhc_malloc_basic(n);\n\
 \}\n\
 \\n\
 \#undef jhc_malloc_atomic\n\
 \static inline void * A_MALLOC\n\
 \jhc_malloc_atomic(size_t n) {\n\
 \        alloc_count(n,1);\n\
 \        return jhc_malloc_basic(n);\n\
 \}\n\
 \\n\
 \\n\
 \#endif\n\
 \\n\
 \#endif\n\
 \/* src/rts/jhc_rts.c */\n\
 \static jmp_buf jhc_uncaught;\n\
 \\n\
 \#ifdef __WIN32__\n\
 \A_UNUSED static char *jhc_options_os =  \"mingw32\";\n\
 \A_UNUSED static char *jhc_options_arch = \"i386\";\n\
 \#else\n\
 \A_UNUSED struct utsname jhc_utsname;\n\
 \A_UNUSED static char *jhc_options_os = \"(unknown os)\";\n\
 \A_UNUSED static char *jhc_options_arch = \"(unknown arch)\";\n\
 \#endif\n\
 \\n\
 \\n\
 \static void A_NORETURN A_UNUSED A_COLD\n\
 \jhc_exit(int n) {\n\
 \        fflush(stdout);\n\
 \        jhc_print_profile();\n\
 \        exit(n);\n\
 \}\n\
 \\n\
 \static void  A_NORETURN A_UNUSED  A_COLD\n\
 \jhc_error(char *s) {\n\
 \        fflush(stdout);\n\
 \        fputs(s,stderr);\n\
 \        fputs(\"\\n\",stderr);\n\
 \        jhc_exit(1);\n\
 \}\n\
 \\n\
 \static void  A_NORETURN A_UNUSED  A_COLD\n\
 \jhc_case_fell_off(int n) {\n\
 \        fflush(stdout);\n\
 \        fprintf(stderr, \"\\n%s:%i: case fell off\\n\", __FILE__, n);\n\
 \        abort();\n\
 \}\n\
 \\n\
 \#define jhc_setjmp(jb) setjmp(*(jb))\n\
 \#define jhc_longjmp(jb) longjmp(*(jb),1)\n\
 \\n\
 \struct jhc_continuation {\n\
 \    void *argument;\n\
 \    jmp_buf jump_buf;\n\
 \};\n\
 \\n\
 \#define prim_umaxbound(t) ((t)~((t)0))\n\
 \#define prim_maxbound(t) ((t)(~((t)1 << (sizeof(t)*8 - 1))))\n\
 \#define prim_minbound(t) ((t)(((t)1 << (sizeof(t)*8 - 1))))\n\
 \\n\
 \void\n\
 \hs_set_argv(int argc, char *argv[])\n\
 \{\n\
 \        jhc_argc = argc - 1;\n\
 \        jhc_argv = argv + 1;\n\
 \        jhc_progname = argv[0];\n\
 \}\n\
 \\n\
 \static int hs_init_count;\n\
 \\n\
 \static void jhc_hs_init(void);\n\
 \\n\
 \void\n\
 \hs_init(int *argc, char **argv[])\n\
 \{\n\
 \\n\
 \        if(!hs_init_count++) {\n\
 \                /* A few random assertions about the architecture that the compiler\n\
 \                 * assumes. should be true of any but the oddest of beasts. */\n\
 \                assert(sizeof(HsPtr) == sizeof(HsFunPtr));\n\
 \                assert(sizeof(HsPtr) == sizeof(intptr_t));\n\
 \                assert(sizeof(HsPtr) == sizeof(uintptr_t));\n\
 \                assert(CHAR_BIT == 8);\n\
 \                assert(EOF == -1);\n\
 \\n\
 \                jhc_alloc_init();\n\
 \                jhc_hs_init();\n\
 \                hs_set_argv(*argc,*argv);\n\
 \#if JHC_isPosix\n\
 \                if(!uname(&jhc_utsname)) {\n\
 \                        jhc_options_arch = jhc_utsname.machine;\n\
 \                        jhc_options_os   = jhc_utsname.sysname;\n\
 \                }\n\
 \#endif\n\
 \                setlocale(LC_ALL,\"\");\n\
 \        }\n\
 \}\n\
 \\n\
 \void\n\
 \hs_exit(void)\n\
 \{\n\
 \        if(!hs_init_count) {\n\
 \                fprintf(stderr, \"hs_exit() called before hs_init()\\n\");\n\
 \                abort();\n\
 \        }\n\
 \        if(!--hs_init_count) {\n\
 \                jhc_alloc_fini();\n\
 \                jhc_exit(0);\n\
 \        }\n\
 \}\n\
 \\n\
 \#if _JHC_STANDALONE\n\
 \int\n\
 \main(int argc, char *argv[])\n\
 \{\n\
 \        hs_init(&argc,&argv);\n\
 \        if (jhc_setjmp(&jhc_uncaught))\n\
 \                jhc_error(\"Uncaught Exception\");\n\
 \        else\n\
 \                _amain();\n\
 \        hs_exit();\n\
 \        return 0;\n\
 \}\n\
 \#endif\n\
 \\n\
 \/* src/rts/profile.c */\n\
 \static void A_UNUSED\n\
 \profile_print_header(FILE *file, char *value_unit)\n\
 \{\n\
 \        fprintf(file, \"JOB \\\"%s\", jhc_progname);\n\
 \        for(int i = 0; i < jhc_argc; i++)\n\
 \                fprintf(file, \" %s\", jhc_argv[i]);\n\
 \        fprintf(file, \"\\\"\\n\");\n\
 \        fprintf(file, \"DATE \\\"%s\\\"\\n\", ctime(NULL));\n\
 \        fprintf(file, \"SAMPLE_UNIT \\\"seconds\\\"\\n\");\n\
 \        fprintf(file, \"VALUE_UNIT \\\"%s\\\"\\n\", value_unit ? value_unit : \"bytes\");\n\
 \}\n\
 \\n\
 \#if _JHC_PROFILE\n\
 \\n\
 \struct profile_stack {\n\
 \    struct tms tm_total;\n\
 \    struct tms tm_pushed;\n\
 \};\n\
 \\n\
 \struct profile_stack gc_alloc_time;\n\
 \struct profile_stack gc_gc_time;\n\
 \\n\
 \\n\
 \void\n\
 \profile_push(struct profile_stack *ps)\n\
 \{\n\
 \        times(&ps->tm_pushed);\n\
 \}\n\
 \\n\
 \void\n\
 \profile_pop(struct profile_stack *ps)\n\
 \{\n\
 \    struct tms tm;\n\
 \    times(&tm);\n\
 \    ps->tm_total.tms_utime += tm.tms_utime - ps->tm_pushed.tms_utime;\n\
 \    ps->tm_total.tms_stime += tm.tms_stime - ps->tm_pushed.tms_stime;\n\
 \}\n\
 \\n\
 \\n\
 \#else\n\
 \\n\
 \#define profile_push(x) do { } while(0)\n\
 \#define profile_pop(x) do { } while(0)\n\
 \\n\
 \#endif\n\
 \\n\
 \#ifndef __WIN32__\n\
 \void print_times(struct tms *tm) {\n\
 \    float cpt = (float)sysconf(_SC_CLK_TCK);\n\
 \    fprintf(stderr, \"User Time:   %.2fs\\n\", (float)tm->tms_utime/cpt);\n\
 \    fprintf(stderr, \"System Time: %.2fs\\n\", (float)tm->tms_stime/cpt);\n\
 \    fprintf(stderr, \"Total Time:  %.2fs\\n\", (float)(tm->tms_stime + tm->tms_utime)/cpt);\n\
 \}\n\
 \#endif\n\
 \\n\
 \static void A_COLD\n\
 \jhc_print_profile(void) {\n\
 \#ifndef __WIN32__\n\
 \        struct tms tm;\n\
 \        times(&tm);\n\
 \#endif\n\
 \        if(!(_JHC_PROFILE || getenv(\"JHC_RTS_PROFILE\"))) return;\n\
 \\n\
 \        fprintf(stderr, \"\\n-----------------\\n\");\n\
 \        fprintf(stderr, \"Profiling: %s\\n\", jhc_progname);\n\
 \        fprintf(stderr, \"Command: %s\\n\", jhc_command);\n\
 \        fprintf(stderr, \"Complie: %s\\n\", jhc_c_compile);\n\
 \        fprintf(stderr, \"Version: %s\\n\\n\", jhc_version);\n\
 \        jhc_alloc_print_stats();\n\
 \#ifndef __WIN32__\n\
 \        print_times(&tm);\n\
 \#if _JHC_PROFILE\n\
 \        print_times(&gc_gc_time.tm_total);\n\
 \        print_times(&gc_alloc_time.tm_total);\n\
 \#endif\n\
 \#endif\n\
 \        fprintf(stderr, \"-----------------\\n\");\n\
 \}\n\
 \/* src/rts/jhc_rts2.c */\n\
 \/*@Internals\n\
 \\n\
 \# The Run Time System\n\
 \\n\
 \Jhc is very minimalist in that it does not have a precompiled run time system,\n\
 \but rather generates what is needed as part of the compilation process.\n\
 \However, back ends do have specific run-time representations of data, which can\n\
 \be affected by things like the choice of garbage collector. The following\n\
 \describes the general layout for the C based back-ends, but compiler options\n\
 \such as garbage collection method or whether we do full program analysis, will\n\
 \affect which features are used and whether certain optimized layouts are\n\
 \possible.\n\
 \\n\
 \Unboxed values directly translate to values in the target language, an unboxed\n\
 \Int will translate directly into an 'int' as an argument and an unboxed pointer\n\
 \will be a raw pointer. Unboxed values have no special interpretation and are\n\
 \_not_ followed by the garbage collector. If the target language does not\n\
 \support a feature such as multiple return values, it will have to be simulated.\n\
 \It would not be wrong to think of Grin code that only deals with unboxed values\n\
 \to be isomorphic to C-- or C augmented with multiple return values.\n\
 \\n\
 \Boxed values have a standard representation and can be followed. Unlike some\n\
 \other implementation, being boxed does not imply the object is located on the\n\
 \heap. It may be on the stack, heap, or even embedded within the smart pointer\n\
 \itself. Being boxed only means that the object may be represented by a smart\n\
 \pointer, which may or may not actually be a pointer in the traditional sense.\n\
 \\n\
 \A boxed value in jhc is represented by a 'smart pointer' of c type sptr_t. a\n\
 \smart pointer is the size of a native pointer, but can take on different roles\n\
 \depending on a pair of tag bits, called the ptype.\n\
 \\n\
 \smart pointers take on a general form as follows:\n\
 \\n\
 \    -------------------------\n\
 \    |    payload        | GL|\n\
 \    -------------------------\n\
 \\n\
 \      G - if set, then the garbage collector should not treat value as a pointer to be followed\n\
 \      L - lazy, this bit being set means the value is potentially not in WHNF\n\
 \\n\
 \A sptr_t on its own in the wild can only take on one of the following forms:\n\
 \\n\
 \    -------------------------\n\
 \    |    whnf raw value | 10|\n\
 \    -------------------------\n\
 \\n\
 \    -------------------------\n\
 \    |    whnf location  | 00|\n\
 \    -------------------------\n\
 \\n\
 \WHNF stands for 'Weak Head Normal Form' and means that the value is not a\n\
 \suspended function and hence not a pointer to a thunk. It may be directly\n\
 \examined and need not be evaluated. wptr_t is an alias for sptr_t that is\n\
 \guarenteed to be of one of the above forms. It is used to improve safety for\n\
 \when we can statically know that a value is WHNF and hence we can skip the\n\
 \expensive 'eval'.\n\
 \\n\
 \The difference between the raw value and the whnf location is that the first\n\
 \contains uninterpreted bits, while the second is a pointer to a location on the\n\
 \heap or stack and hence the garbage collector should follow it. The format of\n\
 \the memory pointed to by the whnf location is unspecified and dependent on the\n\
 \actual type being represented.\n\
 \\n\
 \Partial (unsaturated) applications are normal WHNF values. Saturated\n\
 \applications which may be 'eval'ed and updated are called thunks and must not\n\
 \be pointed to by WHNF pointers. Their representation follows.\n\
 \\n\
 \    -------------------------\n\
 \    |   lazy location   | 01|\n\
 \    -------------------------\n\
 \\n\
 \A lazy location points to either a thunk, or a redirection to a WHNF value. A\n\
 \lazy location is always a pointer to an allocated block of memory which always\n\
 \begins with a restricted smart pointer. This restricted smart pointer is represented by\n\
 \the C type alias 'fptr_t'. fptr_t's only occur as the first entry in a lazy\n\
 \location, they never are passed around as objects in their own right.\n\
 \\n\
 \A fptr_t may be a whnf value or a code pointer. If a fptr_t is a whnf value (of one of\n\
 \the two forms given above) then it is called a redirection, the lazy location should be\n\
 \treated exactly as if it were the whnf given. This is used to redirect an evaluated\n\
 \thunk to its computed value.\n\
 \\n\
 \A fptr_t may also be a 'code pointer' in which case the lazy location is called\n\
 \a thunk. A code pointer is a pointer to executable machine code that evaluates\n\
 \a closure and returns a wptr_t, the returned wptr_t is then generally written\n\
 \over the code pointer, turning the thunk into a redirection. It is the\n\
 \responsibility of the code pointed to to perform this redirection.\n\
 \\n\
 \    -------------------------\n\
 \    |    code pointer   | 11|\n\
 \    -------------------------\n\
 \    |     data ...          |\n\
 \\n\
 \When debugging, the special code pointer BLACK_HOLE is also sometimes stored in\n\
 \a fptr_t to detect certain run-time errors.\n\
 \\n\
 \Note that unlike other implementations, a fptr_t may _not_ be another lazy\n\
 \location. you can not have chained redirections, a redirection is always a\n\
 \redirection to a whnf value.\n\
 \\n\
 \    sptr_t - a tagged smart pointer, may contain a whnf value or a lazy location.\n\
 \    wptr_t - a tagged smart pointer that contains a whnf value (either raw or a location)\n\
 \    fptr_t - a tagged smart pointer, may contain a whnf value indicating a redirection, or a code pointer indicating a thunk.\n\
 \\n\
 \*/\n\
 \\n\
 \#define P_WHNF  0x0\n\
 \#define P_LAZY  0x1\n\
 \#define P_VALUE 0x2\n\
 \#define P_FUNC  0x3\n\
 \\n\
 \#define IS_LAZY(x)     (bool)(((uintptr_t)(x)) & 0x1)\n\
 \#define IS_PTR(x)      (bool)(!(((uintptr_t)(x)) & 0x2))\n\
 \\n\
 \#define FROM_SPTR(x)   (typeof (x))((uintptr_t)(x) & ~0x3)  // remove a ptype from a smart pointer\n\
 \#define GET_PTYPE(x)   ((uintptr_t)(x) & 0x3)               // return the ptype associated with a smart pointer\n\
 \#define TO_SPTR(t,x)   (typeof (x))((uintptr_t)(x) | (t))   // attach a ptype to a smart pointer\n\
 \#define TO_SPTR_C(t,x) (typeof (x))((uintptr_t)(x) + (t))   // attach a ptype to a smart pointer, suitable for use by constant initialializers\n\
 \\n\
 \#define GETHEAD(x)   (NODEP(x)->head)\n\
 \#define NODEP(x)     ((node_t *)(x))\n\
 \#define DNODEP(x)    ((dnode_t *)(x))\n\
 \\n\
 \#define MKLAZY(fn)    TO_SPTR(P_LAZY,(sptr_t)fn)\n\
 \#define MKLAZY_C(fn)  TO_SPTR_C(P_LAZY,(sptr_t)fn)\n\
 \#define TO_FPTR(fn)   TO_SPTR_C(P_FUNC,(fptr_t)fn)\n\
 \\n\
 \#define RAW_SET_F(n)   ((wptr_t)(((intptr_t)(n) << 2) | P_VALUE))\n\
 \#define RAW_SET_UF(n)  ((wptr_t)(((uintptr_t)(n) << 2) | P_VALUE))\n\
 \#define RAW_GET_F(n)   ((intptr_t)(n) >> 2)\n\
 \#define RAW_GET_UF(n)  ((uintptr_t)(n) >> 2)\n\
 \\n\
 \#define RAW_SET_16(w)  (wptr_t)(((uintptr_t)(w) << 16) | P_VALUE)\n\
 \#define RAW_GET_16(n)  ((intptr_t)(n) >> 16)\n\
 \#define RAW_GET_U16(n) ((uintptr_t)(n) >> 16)\n\
 \\n\
 \// demote is always safe, we must only promote when we know the argument is a WHNF\n\
 \#define PROMOTE(n)   ((wptr_t)(n))\n\
 \#define DEMOTE(n)    ((sptr_t)(n))\n\
 \\n\
 \#define FETCH_TAG(x)      RAW_GET_U16(IS_PTR(x) ? FETCH_MEM_TAG(x) : (what_t)(x))\n\
 \#define FETCH_RAW_TAG(x)  RAW_GET_U16(x)\n\
 \#define SET_RAW_TAG(x)    RAW_SET_16(x)\n\
 \#define FETCH_MEM_TAG(x)  (DNODEP(x)->what)\n\
 \#define SET_MEM_TAG(x,v)  (DNODEP(x)->what = (what_t)RAW_SET_16(v))\n\
 \\n\
 \\n\
 \\n\
 \#define BLACK_HOLE TO_FPTR(0xDEADBEE0)\n\
 \\n\
 \struct sptr {};\n\
 \struct wptr {};\n\
 \struct fptr {};\n\
 \\n\
 \// we use dummy structs here so the compiler will catch any attempt\n\
 \// to use one type in anothers place\n\
 \typedef struct sptr * sptr_t;\n\
 \typedef struct wptr * wptr_t;\n\
 \typedef struct fptr * fptr_t;\n\
 \typedef uintptr_t     what_t;\n\
 \\n\
 \\n\
 \typedef struct node {\n\
 \        fptr_t head;\n\
 \        sptr_t rest[];\n\
 \} A_MAYALIAS node_t;\n\
 \\n\
 \typedef struct dnode {\n\
 \        what_t what;\n\
 \        sptr_t rest[];\n\
 \} A_MAYALIAS dnode_t;\n\
 \\n\
 \#if _JHC_DEBUG\n\
 \\n\
 \// these ensure the type synonyms are available to the debugger\n\
 \uintptr_t _dummy1;\n\
 \node_t *_dummy2;\n\
 \dnode_t *_dummy3;\n\
 \sptr_t *_dummy4;\n\
 \fptr_t *_dummy5;\n\
 \wptr_t *_dummy6;\n\
 \\n\
 \\n\
 \static bool A_UNUSED\n\
 \jhc_valid_whnf(wptr_t s)\n\
 \{\n\
 \        return ((GET_PTYPE(s) == P_VALUE) || ((GET_PTYPE(s) == P_WHNF) && jhc_malloc_sanity(s,P_WHNF)));\n\
 \}\n\
 \\n\
 \static bool A_UNUSED\n\
 \jhc_valid_lazy(sptr_t s)\n\
 \{\n\
 \        if(jhc_valid_whnf((wptr_t)s))\n\
 \                return true;\n\
 \        assert(GET_PTYPE(s) == P_LAZY);\n\
 \        node_t *ds = (node_t *)FROM_SPTR(s);\n\
 \        assert(jhc_malloc_sanity(ds,P_LAZY));\n\
 \        if(IS_LAZY(ds->head)) {\n\
 \                if(ds->head == BLACK_HOLE) return true;\n\
 \                assert(GET_PTYPE(ds->head) == P_FUNC);\n\
 \                return true;\n\
 \        } else\n\
 \                return jhc_valid_whnf((wptr_t)ds->head);\n\
 \}\n\
 \\n\
 \\n\
 \#else\n\
 \\n\
 \#define jhc_valid_whnf(x) true\n\
 \#define jhc_valid_lazy(x) true\n\
 \\n\
 \#endif\n\
 \\n\
 \\n\
 \#if _JHC_GC == _JHC_GC_JGC\n\
 \typedef wptr_t (*eval_fn)(gc_t gc,node_t *node) A_STD;\n\
 \#else\n\
 \typedef wptr_t (*eval_fn)(node_t *node) A_STD;\n\
 \#endif\n\
 \\n\
 \// both promote and demote evaluate to nothing when debugging is not enabled\n\
 \// otherwise, they check that their arguments are in the correct form.\n\
 \\n\
 \static inline wptr_t A_STD A_UNUSED  A_HOT\n\
 \promote(sptr_t s)\n\
 \{\n\
 \        assert(!IS_LAZY(s));\n\
 \        assert(jhc_valid_whnf((wptr_t)s));\n\
 \        return (wptr_t)s;\n\
 \}\n\
 \\n\
 \static inline sptr_t A_STD A_UNUSED A_HOT\n\
 \demote(wptr_t s)\n\
 \{\n\
 \        assert(!IS_LAZY(s));\n\
 \        assert(jhc_valid_whnf(s));\n\
 \        return (sptr_t)s;\n\
 \}\n\
 \\n\
 \// like eval but you know the target is in WHNF or is a already evaluated indirection\n\
 \static inline wptr_t A_STD A_UNUSED  A_HOT\n\
 \follow(sptr_t s)\n\
 \{\n\
 \        assert(jhc_valid_lazy(s));\n\
 \        if(IS_LAZY(s)) {\n\
 \                sptr_t h = (sptr_t)(GETHEAD(FROM_SPTR(s)));\n\
 \                assert(!IS_LAZY(h));\n\
 \                return (wptr_t)h;\n\
 \        }\n\
 \        return (wptr_t)s;\n\
 \}\n\
 \\n\
 \static wptr_t A_STD A_UNUSED  A_HOT\n\
 \#if _JHC_GC == _JHC_GC_JGC\n\
 \eval(gc_t gc,sptr_t s)\n\
 \#else\n\
 \eval(sptr_t s)\n\
 \#endif\n\
 \{\n\
 \        assert(jhc_valid_lazy(s));\n\
 \        if(IS_LAZY(s)) {\n\
 \                assert(GET_PTYPE(s) == P_LAZY);\n\
 \                void *ds = FROM_SPTR(s);\n\
 \                sptr_t h = (sptr_t)(GETHEAD(ds));\n\
 \                assert((fptr_t)h != BLACK_HOLE);\n\
 \                if(IS_LAZY(h)) {\n\
 \                        eval_fn fn = (eval_fn)FROM_SPTR(h);\n\
 \                        assert(GET_PTYPE(h) == P_FUNC);\n\
 \#if _JHC_DEBUG\n\
 \                        GETHEAD(ds) = BLACK_HOLE;\n\
 \#endif\n\
 \#if _JHC_GC == _JHC_GC_JGC\n\
 \                        wptr_t r = (*fn)(gc,NODEP(ds));\n\
 \#else\n\
 \                        wptr_t r = (*fn)(NODEP(ds));\n\
 \#endif\n\
 \#if _JHC_DEBUG\n\
 \                        assert(GETHEAD(ds) != BLACK_HOLE);\n\
 \#endif\n\
 \                        return r;\n\
 \                }\n\
 \                return (wptr_t)h;\n\
 \        }\n\
 \        assert(jhc_valid_whnf((wptr_t)s));\n\
 \        return (wptr_t)s;\n\
 \}\n\
 \\n\
 \\n\
 \static void A_STD A_UNUSED A_HOT\n\
 \update(void * thunk, wptr_t new)\n\
 \{\n\
 \        assert(GETHEAD(thunk) == BLACK_HOLE);\n\
 \        assert(!IS_LAZY(new));\n\
 \        GETHEAD(thunk) = (fptr_t)new;\n\
 \}\n\
 \/* src/rts/bitarray.h */\n\
 \#ifndef BITARRAY_H\n\
 \#define BITARRAY_H\n\
 \\n\
 \#include <limits.h>\n\
 \#include <stdbool.h>\n\
 \\n\
 \typedef unsigned long bitarray_t;\n\
 \\n\
 \#define BITS_PER_UNIT (bitarray_t)(CHAR_BIT*sizeof(bitarray_t))\n\
 \#define BITARRAY_SIZE(bits) (((bits) + (BITS_PER_UNIT - 1)) / BITS_PER_UNIT)\n\
 \#define BITARRAY_SIZE_IN_BYTES(bits) (sizeof(bitarray_t)*BITARRAY_SIZE(bits))\n\
 \\n\
 \#define WHICH_BIT(bit)  \\\n\
 \    (1UL << ((((bitarray_t)(bit)) % BITS_PER_UNIT)))\n\
 \\n\
 \#define OFFSET_IN_ARRAY(array,bit) \\\n\
 \    (((bitarray_t *)(array))[((bitarray_t)(bit)) / BITS_PER_UNIT])\n\
 \\n\
 \#define BIT_IS_SET(array,bit)  \\\n\
 \    (OFFSET_IN_ARRAY(array,bit) & WHICH_BIT(bit))\n\
 \\n\
 \#define BIT_IS_UNSET(array,bit) \\\n\
 \    (!(BIT_IS_SET(array,bit)))\n\
 \\n\
 \#define BIT_SET(array,bit) \\\n\
 \    (OFFSET_IN_ARRAY(array,bit) |= WHICH_BIT(bit))\n\
 \\n\
 \#define BIT_UNSET(array,bit) \\\n\
 \    (OFFSET_IN_ARRAY(array,bit) &= ~WHICH_BIT(bit))\n\
 \\n\
 \#define BIT_TOGGLE(array,bit) \\\n\
 \    (OFFSET_IN_ARRAY(array,bit) ^= WHICH_BIT(bit))\n\
 \\n\
 \#define BIT_COPY(dest,src,bit)  \\\n\
 \    do { BIT_IS_SET((src),(bit)) ? BIT_SET((dest),(bit)) : BIT_UNSET((dest),(bit)) } while(0)\n\
 \\n\
 \#define BIT_VALUE(array,bit) \\\n\
 \    (BIT_IS_SET((array),(bit)) ? true : false)\n\
 \\n\
 \#define BIT_SET_VALUE(array,bit,value) \\\n\
 \    do { (value) ? BIT_SET((array),(bit)) : BIT_UNSET((array),(bit)) } while(0)\n\
 \\n\
 \#endif\n\
 \/* src/rts/slub.c */\n\
 \#if _JHC_GC == _JHC_GC_JGC\n\
 \/*\n\
 \ * Singly-linked List definitions.\n\
 \ */\n\
 \#define\x0009\&SLIST_HEAD(name, type)\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \struct name {\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \\x0009\&struct type *slh_first;\x0009\&/* first element */\x0009\&\x0009\&\x0009\&\\\n\
 \}\n\
 \#define\x0009\&SLIST_ENTRY(type)\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \struct {\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \\x0009\&struct type *sle_next;\x0009\&/* next element */\x0009\&\x0009\&\x0009\&\\\n\
 \}\n\
 \#define\x0009\&SLIST_INIT(head) do {\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \\x0009\&(head)->slh_first = NULL;\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \} while (/*CONSTCOND*/0)\n\
 \#define\x0009\&SLIST_INSERT_HEAD(head, elm, field) do {\x0009\&\x0009\&\x0009\&\\\n\
 \\x0009\&(elm)->field.sle_next = (head)->slh_first;\x0009\&\x0009\&\x0009\&\\\n\
 \\x0009\&(head)->slh_first = (elm);\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \} while (/*CONSTCOND*/0)\n\
 \#define\x0009\&SLIST_REMOVE_HEAD(head, field) do {\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \\x0009\&(head)->slh_first = (head)->slh_first->field.sle_next;\x0009\&\x0009\&\\\n\
 \} while (/*CONSTCOND*/0)\n\
 \#define\x0009\&SLIST_FIRST(head)\x0009\&((head)->slh_first)\n\
 \#define\x0009\&SLIST_NEXT(elm, field)\x0009\&((elm)->field.sle_next)\n\
 \#define\x0009\&SLIST_FOREACH(var, head, field)\x0009\&\x0009\&\x0009\&\x0009\&\x0009\&\\\n\
 \\x0009\&for((var) = (head)->slh_first; (var); (var) = (var)->field.sle_next)\n\
 \\n\
 \\n\
 \#define BLOCK_SIZE     (1UL << 12)\n\
 \#define MEGABLOCK_SIZE (1UL << 20)\n\
 \\n\
 \\n\
 \#define S_BLOCK(val) (struct s_block *)((uintptr_t)(val) & ~ (BLOCK_SIZE - 1))\n\
 \\n\
 \struct s_arena {\n\
 \        struct s_megablock *current_megablock;\n\
 \        SLIST_HEAD(,s_block) free_blocks;\n\
 \        unsigned block_used;\n\
 \        unsigned block_threshold;\n\
 \        SLIST_HEAD(,s_cache) caches;\n\
 \        SLIST_HEAD(,s_megablock) megablocks;\n\
 \};\n\
 \\n\
 \struct s_megablock {\n\
 \        void *base;\n\
 \        unsigned next_free;\n\
 \        SLIST_ENTRY(s_megablock) next;\n\
 \};\n\
 \\n\
 \struct s_block_info {\n\
 \        unsigned char color;\n\
 \        unsigned char size;\n\
 \        unsigned char num_ptrs;\n\
 \};\n\
 \\n\
 \struct s_block {\n\
 \        SLIST_ENTRY(s_block) link;\n\
 \        struct s_block_info pi;\n\
 \        unsigned short num_free;\n\
 \        unsigned short next_free;\n\
 \        bitarray_t used[];\n\
 \};\n\
 \\n\
 \struct s_cache {\n\
 \        SLIST_ENTRY(s_cache) next;\n\
 \        SLIST_HEAD(,s_block) blocks;\n\
 \        SLIST_HEAD(,s_block) full_blocks;\n\
 \        struct s_block_info pi;\n\
 \        unsigned short num_entries;\n\
 \        struct s_arena *arena;\n\
 \};\n\
 \\n\
 \\n\
 \/* This finds a bit that isn't set, sets it, then returns its index.  It\n\
 \ * assumes that a bit is available to be found, otherwise it goes into an\n\
 \ * infinite loop. */\n\
 \\n\
 \static unsigned\n\
 \bitset_find_free(unsigned *next_free,int n,bitarray_t ba[static n]) {\n\
 \        assert(*next_free < (unsigned)n);\n\
 \        unsigned i = *next_free;\n\
 \        do {\n\
 \                int o = __builtin_ffsl(~ba[i]);\n\
 \                if(__predict_true(o)) {\n\
 \                        ba[i] |= (1UL << (o - 1));\n\
 \                        *next_free = i;\n\
 \                        return (i*BITS_PER_UNIT + (o - 1));\n\
 \                }\n\
 \                i = (i + 1) % n;\n\
 \                assert(i != *next_free);\n\
 \        } while (1);\n\
 \}\n\
 \\n\
 \struct s_megablock *\n\
 \s_new_megablock(struct s_arena *arena)\n\
 \{\n\
 \        struct s_megablock *mb = malloc(sizeof(*mb));\n\
 \#if defined(__WIN32__)\n\
 \        mb->base = _aligned_malloc(MEGABLOCK_SIZE, BLOCK_SIZE);\n\
 \        int ret = !mb->base;\n\
 \#elif (defined(__ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__) && __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ <  1060)\n\
 \        assert(sysconf(_SC_PAGESIZE) == BLOCK_SIZE);\n\
 \        mb->base = valloc(MEGABLOCK_SIZE);\n\
 \        int ret = !mb->base;\n\
 \#else\n\
 \        int ret = posix_memalign(&mb->base,BLOCK_SIZE,MEGABLOCK_SIZE);\n\
 \#endif\n\
 \        if(ret != 0) {\n\
 \                fprintf(stderr,\"Unable to allocate memory for megablock\\n\");\n\
 \                abort();\n\
 \        }\n\
 \        VALGRIND_MAKE_MEM_NOACCESS(mb->base,MEGABLOCK_SIZE);\n\
 \        //VALGRIND_FREELIKE_BLOCK(mb->base,0);\n\
 \        mb->next_free = 0;\n\
 \        return mb;\n\
 \}\n\
 \\n\
 \/* block allocator */\n\
 \\n\
 \static unsigned block_threshold = 8;\n\
 \\n\
 \static struct s_block *\n\
 \get_free_block(gc_t gc, struct s_arena *arena) {\n\
 \        arena->block_used++;\n\
 \        if(__predict_true(SLIST_FIRST(&arena->free_blocks))) {\n\
 \                struct s_block *pg = SLIST_FIRST(&arena->free_blocks);\n\
 \                SLIST_REMOVE_HEAD(&arena->free_blocks,link);\n\
 \                return pg;\n\
 \        } else {\n\
 \                if((arena->block_used >= arena->block_threshold)) {\n\
 \                        gc_perform_gc(gc);\n\
 \                        // if we are still using 80% of the heap after a gc, raise the threshold.\n\
 \                        if(__predict_false((unsigned)arena->block_used * 10 >= arena->block_threshold * 9)) {\n\
 \                                arena->block_threshold *= 2;\n\
 \                        }\n\
 \                }\n\
 \                if(__predict_false(!arena->current_megablock))\n\
 \                        arena->current_megablock = s_new_megablock(arena);\n\
 \                struct s_megablock *mb = arena->current_megablock;\n\
 \                struct s_block *pg = mb->base + BLOCK_SIZE*mb->next_free;\n\
 \                mb->next_free++;\n\
 \                if(mb->next_free == MEGABLOCK_SIZE / BLOCK_SIZE) {\n\
 \                        SLIST_INSERT_HEAD(&arena->megablocks,mb, next);\n\
 \                        arena->current_megablock = NULL;\n\
 \                }\n\
 \                VALGRIND_MAKE_MEM_UNDEFINED(pg,sizeof(struct s_block));\n\
 \                pg->num_free = 0;\n\
 \                return pg;\n\
 \        }\n\
 \}\n\
 \\n\
 \static void\n\
 \s_cleanup_blocks(struct s_arena *arena) {\n\
 \        struct s_cache *sc = SLIST_FIRST(&arena->caches);\n\
 \        for(;sc;sc = SLIST_NEXT(sc,next)) {\n\
 \\n\
 \                // 'best' keeps track of the block with the fewest free spots\n\
 \                // and percolates it to the front, effectively a single pass\n\
 \                // of a bubblesort to help combat fragmentation. It does\n\
 \                // not increase the complexity of the cleanup algorithm as\n\
 \                // we had to scan every block anyway, but over many passes\n\
 \                // of the GC it will eventually result in a more sorted list\n\
 \                // than would occur by chance.\n\
 \\n\
 \                struct s_block *best = NULL;\n\
 \                int free_best = 4096;\n\
 \                struct s_block *pg = SLIST_FIRST(&sc->blocks);\n\
 \                struct s_block *fpg = SLIST_FIRST(&sc->full_blocks);\n\
 \                SLIST_INIT(&sc->blocks);\n\
 \                SLIST_INIT(&sc->full_blocks);\n\
 \                if(!pg) {\n\
 \                        pg = fpg;\n\
 \                        fpg = NULL;\n\
 \                }\n\
 \                while(pg) {\n\
 \                        struct s_block *npg = SLIST_NEXT(pg,link);\n\
 \                        if(__predict_false(pg->num_free == 0)) {\n\
 \                                SLIST_INSERT_HEAD(&sc->full_blocks,pg,link);\n\
 \                        } else if(__predict_true(pg->num_free == sc->num_entries)) {\n\
 \                                arena->block_used--;\n\
 \                                VALGRIND_MAKE_MEM_NOACCESS((char *)pg + sizeof(struct s_block), BLOCK_SIZE - sizeof(struct s_block));\n\
 \                                SLIST_INSERT_HEAD(&arena->free_blocks,pg,link);\n\
 \                        } else {\n\
 \                                if(!best) {\n\
 \                                        free_best = pg->num_free;\n\
 \                                        best = pg;\n\
 \                                } else {\n\
 \                                        if(pg->num_free < free_best) {\n\
 \                                                struct s_block *tmp = best;\n\
 \                                                best = pg; pg = tmp;\n\
 \                                                free_best = pg->num_free;\n\
 \                                        }\n\
 \                                        SLIST_INSERT_HEAD(&sc->blocks,pg,link);\n\
 \                                }\n\
 \                        }\n\
 \                        if(!npg && fpg) {\n\
 \                                pg = fpg;\n\
 \                                fpg = NULL;\n\
 \                        } else\n\
 \                                pg = npg;\n\
 \                }\n\
 \                if(best)\n\
 \                        SLIST_INSERT_HEAD(&sc->blocks,best,link);\n\
 \        }\n\
 \}\n\
 \\n\
 \inline static void\n\
 \clear_block_used_bits(unsigned num_entries, struct s_block *pg)\n\
 \{\n\
 \        pg->num_free = num_entries;\n\
 \        memset(pg->used,0,BITARRAY_SIZE_IN_BYTES(num_entries) - sizeof(pg->used[0]));\n\
 \        int excess = num_entries % BITS_PER_UNIT;\n\
 \        pg->used[BITARRAY_SIZE(num_entries) - 1] = ~((1UL << excess) - 1);\n\
 \#if JHC_VALGRIND\n\
 \                unsigned header =  sizeof(struct s_block) + BITARRAY_SIZE_IN_BYTES(num_entries);\n\
 \                VALGRIND_MAKE_MEM_NOACCESS((char *)pg + header, BLOCK_SIZE - header);\n\
 \#endif\n\
 \}\n\
 \\n\
 \static void *\n\
 \s_alloc(gc_t gc, struct s_cache *sc)\n\
 \{\n\
 \        struct s_block *pg = SLIST_FIRST(&sc->blocks);\n\
 \        if(__predict_false(!pg)) {\n\
 \                pg = get_free_block(gc, sc->arena);\n\
 \                VALGRIND_MAKE_MEM_NOACCESS(pg, BLOCK_SIZE);\n\
 \                VALGRIND_MAKE_MEM_DEFINED(pg, sizeof(struct s_block));\n\
 \                if(sc->num_entries != pg->num_free)\n\
 \                        VALGRIND_MAKE_MEM_UNDEFINED((char *)pg->used,BITARRAY_SIZE_IN_BYTES(sc->num_entries));\n\
 \                else\n\
 \                        VALGRIND_MAKE_MEM_DEFINED((char *)pg->used,BITARRAY_SIZE_IN_BYTES(sc->num_entries));\n\
 \                assert(pg);\n\
 \                pg->pi = sc->pi;\n\
 \                pg->next_free = 0;\n\
 \                SLIST_INSERT_HEAD(&sc->blocks,pg,link);\n\
 \                if(sc->num_entries != pg->num_free)\n\
 \                        clear_block_used_bits(sc->num_entries, pg);\n\
 \                pg->used[0] = 1; //set the first bit\n\
 \                pg->num_free = sc->num_entries - 1;\n\
 \                return (uintptr_t *)pg + pg->pi.color;\n\
 \        } else {\n\
 \                __builtin_prefetch(pg->used,1);\n\
 \                pg->num_free--;\n\
 \                unsigned next_free = pg->next_free;\n\
 \                unsigned found = bitset_find_free(&next_free,BITARRAY_SIZE(sc->num_entries),pg->used);\n\
 \                pg->next_free = next_free;\n\
 \                void *val = (uintptr_t *)pg + pg->pi.color + found*pg->pi.size;\n\
 \                if(__predict_false(0 == pg->num_free)) {\n\
 \                        assert(pg == SLIST_FIRST(&sc->blocks));\n\
 \                        SLIST_REMOVE_HEAD(&sc->blocks,link);\n\
 \                        SLIST_INSERT_HEAD(&sc->full_blocks,pg,link);\n\
 \                }\n\
 \                assert(S_BLOCK(val) == pg);\n\
 \                //printf(\"s_alloc: val: %p s_block: %p size: %i color: %i found: %i num_free: %i\\n\", val, pg, pg->pi.size, pg->pi.color, found, pg->num_free);\n\
 \                return val;\n\
 \        }\n\
 \}\n\
 \\n\
 \/*\n\
 \static void\n\
 \s_free(void *val)\n\
 \{\n\
 \        assert(val);\n\
 \        struct s_block *pg = s_block(val);\n\
 \        unsigned int offset = ((uintptr_t *)val - (uintptr_t *)pg) - pg->pi.color;\n\
 \//        printf(\"s_free:  val: %p s_block: %p size: %i color: %i num_free: %i offset: %i bit: %i\\n\", val, pg, pg->pi.size, pg->pi.color, pg->num_free, offset, offset/pg->pi.size);\n\
 \        assert(BIT_VALUE(pg->used,offset/(pg->pi.size)));\n\
 \        BIT_UNSET(pg->used,offset/(pg->pi.size));\n\
 \        pg->num_free++;\n\
 \}\n\
 \*/\n\
 \\n\
 \static struct s_cache *\n\
 \new_cache(struct s_arena *arena, unsigned short size, unsigned short num_ptrs)\n\
 \{\n\
 \        struct s_cache *sc = malloc(sizeof(*sc));\n\
 \        sc->arena = arena;\n\
 \        sc->pi.size = size;\n\
 \        sc->pi.num_ptrs = num_ptrs;\n\
 \        size_t excess = BLOCK_SIZE - sizeof(struct s_block);\n\
 \        sc->num_entries = (8*excess) / (8*sizeof(uintptr_t)*size + 1) - 1;\n\
 \        //sc->num_entries = (8*excess) / (8*size*sizeof(uintptr_t) + 1);\n\
 \        sc->pi.color = (sizeof(struct s_block) + BITARRAY_SIZE_IN_BYTES(sc->num_entries) + sizeof(uintptr_t) - 1) / sizeof(uintptr_t);\n\
 \        SLIST_INIT(&sc->blocks);\n\
 \        SLIST_INIT(&sc->full_blocks);\n\
 \        SLIST_INSERT_HEAD(&arena->caches,sc,next);\n\
 \        //print_cache(sc);\n\
 \        return sc;\n\
 \}\n\
 \\n\
 \\n\
 \// clear all used bits, must be followed by a marking phase.\n\
 \static void\n\
 \clear_used_bits(struct s_arena *arena)\n\
 \{\n\
 \        struct s_cache *sc = SLIST_FIRST(&arena->caches);\n\
 \        for(;sc;sc = SLIST_NEXT(sc,next)) {\n\
 \                struct s_block *pg = SLIST_FIRST(&sc->blocks);\n\
 \                struct s_block *fpg = SLIST_FIRST(&sc->full_blocks);\n\
 \                do {\n\
 \                        for(;pg;pg = SLIST_NEXT(pg,link))\n\
 \                                clear_block_used_bits(sc->num_entries,pg);\n\
 \                        pg = fpg;\n\
 \                        fpg = NULL;\n\
 \                }  while(pg);\n\
 \        }\n\
 \}\n\
 \\n\
 \// set a used bit. returns true if the\n\
 \// tagged node should be scanned by the GC.\n\
 \// this happens when the used bit was not previously set\n\
 \// and the node contains internal pointers.\n\
 \\n\
 \static bool\n\
 \s_set_used_bit(void *val)\n\
 \{\n\
 \        assert(val);\n\
 \        struct s_block *pg = S_BLOCK(val);\n\
 \        unsigned int offset = ((uintptr_t *)val - (uintptr_t *)pg) - pg->pi.color;\n\
 \        if(__predict_true(BIT_IS_UNSET(pg->used,offset/pg->pi.size))) {\n\
 \                BIT_SET(pg->used,offset/pg->pi.size);\n\
 \                pg->num_free--;\n\
 \                return (bool)pg->pi.num_ptrs;\n\
 \        }\n\
 \        return false;\n\
 \}\n\
 \\n\
 \static struct s_cache *\n\
 \find_cache(struct s_cache **rsc, struct s_arena *arena, unsigned short size, unsigned short num_ptrs)\n\
 \{\n\
 \        if(__predict_true(rsc && *rsc))\n\
 \                return *rsc;\n\
 \        struct s_cache *sc = SLIST_FIRST(&arena->caches);\n\
 \        for(;sc;sc = SLIST_NEXT(sc,next)) {\n\
 \                if(sc->pi.size == size && sc->pi.num_ptrs == num_ptrs)\n\
 \                        goto found;\n\
 \        }\n\
 \        sc = new_cache(arena,size,num_ptrs);\n\
 \found:\n\
 \        if(rsc)\n\
 \                *rsc = sc;\n\
 \        return sc;\n\
 \}\n\
 \\n\
 \struct s_arena *\n\
 \new_arena(void) {\n\
 \        struct s_arena *arena = malloc(sizeof(struct s_arena));\n\
 \        SLIST_INIT(&arena->caches);\n\
 \        SLIST_INIT(&arena->free_blocks);\n\
 \        SLIST_INIT(&arena->megablocks);\n\
 \        arena->block_used = 0;\n\
 \        arena->block_threshold = 8;\n\
 \        arena->current_megablock = NULL;\n\
 \        return arena;\n\
 \}\n\
 \\n\
 \void\n\
 \print_cache(struct s_cache *sc) {\n\
 \        fprintf(stderr, \"num_entries: %i\\n\",(int)sc->num_entries);\n\
 \//        printf(\"  entries: %i words\\n\",(int)(sc->num_entries*sc->pi.size));\n\
 \        fprintf(stderr, \"  header: %lu bytes\\n\", sizeof(struct s_block) + BITARRAY_SIZE_IN_BYTES(sc->num_entries));\n\
 \        fprintf(stderr, \"  size: %i words\\n\",(int)sc->pi.size);\n\
 \//        printf(\"  color: %i words\\n\",(int)sc->pi.color);\n\
 \        fprintf(stderr, \"  nptrs: %i words\\n\",(int)sc->pi.num_ptrs);\n\
 \//        printf(\"  end: %i bytes\\n\",(int)(sc->pi.color+ sc->num_entries*sc->pi.size)*sizeof(uintptr_t));\n\
 \        fprintf(stderr, \"%20s %9s %9s %s\\n\", \"block\", \"num_free\", \"next_free\", \"status\");\n\
 \        struct s_block *pg;\n\
 \        SLIST_FOREACH(pg,&sc->blocks,link) {\n\
 \            fprintf(stderr, \"%20p %9i %9i %c\\n\", pg, pg->num_free, pg->next_free, 'P');\n\
 \        }\n\
 \        fprintf(stderr, \"  full_blocks:\\n\");\n\
 \        SLIST_FOREACH(pg,&sc->full_blocks,link) {\n\
 \            fprintf(stderr, \"%20p %9i %9i %c\\n\", pg, pg->num_free, pg->next_free, 'F');\n\
 \        }\n\
 \}\n\
 \\n\
 \#ifdef SLAB_TEST\n\
 \\n\
 \#define NUM_CACHES 15\n\
 \#define FACTOR (1 << 16)\n\
 \\n\
 \void\n\
 \stress_test(int n) {\n\
 \        struct s_arena *arena = new_arena();\n\
 \        struct s_cache *caches[NUM_CACHES];\n\
 \\n\
 \        void *ptrs[n];\n\
 \        memset(ptrs,0,n*sizeof(void *));\n\
 \        for(int i = 0; i < NUM_CACHES; i++)\n\
 \                caches[i] = new_cache(arena,sizeof(void *)*(i + 1), 0);\n\
 \        for(int i = 0; i < FACTOR * n; i++) {\n\
 \                int wp = rand() % n;\n\
 \                if (ptrs[wp]) {\n\
 \                        s_free(ptrs[wp]);\n\
 \                        //free(ptrs[wp]);\n\
 \                        ptrs[wp] = NULL;\n\
 \                } else {\n\
 \                        ptrs[wp] = s_alloc(caches[rand() % NUM_CACHES]);\n\
 \                        //ptrs[wp] = malloc((rand() % NUM_CACHES) * sizeof(uintptr_t));\n\
 \                }\n\
 \        }\n\
 \}\n\
 \\n\
 \\n\
 \int\n\
 \main(int argc, char *argv[])\n\
 \{\n\
 \\n\
 \        setbuf(stdout,NULL);\n\
 \        stress_test(1 << 8);\n\
 \        struct s_arena *arena = new_arena();\n\
 \        for(int i = 0;i < 10; i++) {\n\
 \        struct s_cache *sc = new_cache(arena,i,0);\n\
 \        print_cache(sc);\n\
 \        }\n\
 \        struct s_cache *sc1 = new_cache(arena,7,4);\n\
 \        struct s_cache *sc2 = new_cache(arena,1,3);\n\
 \\n\
 \        printf(\"Alloc1: %p\\n\", s_alloc(sc1));\n\
 \        printf(\"Alloc1: %p\\n\", s_alloc(sc1));\n\
 \        printf(\"Alloc1: %p\\n\", s_alloc(sc1));\n\
 \        printf(\"Alloc2: %p\\n\", s_alloc(sc2));\n\
 \        printf(\"Alloc2: %p\\n\", s_alloc(sc2));\n\
 \        printf(\"Alloc2: %p\\n\", s_alloc(sc2));\n\
 \\n\
 \        print_cache(sc1);\n\
 \        print_cache(sc2);\n\
 \\n\
 \\n\
 \        return 0;\n\
 \}\n\
 \\n\
 \#endif\n\
 \#endif\n\
 \/* src/rts/jhc_jgc.c */\n\
 \#if _JHC_GC == _JHC_GC_JGC\n\
 \static struct s_arena *arena;\n\
 \\n\
 \#ifdef JHC_JGC_STACK\n\
 \struct frame {\n\
 \        struct frame *prev;\n\
 \        unsigned nptrs;\n\
 \        void *ptrs[0];\n\
 \};\n\
 \#define gc_frame0(gc,n,...) struct { struct frame *prev; unsigned nptrs;void *ptrs[n]; } l \\\n\
 \          = { gc, n, { __VA_ARGS__ } }; gc_t gc = (gc_t)(void *)&l;\n\
 \#else\n\
 \#define gc_frame0(gc,n,...) void *ptrs[n] = { __VA_ARGS__ }; for(int i = 0; i < n; i++) gc[i] = (sptr_t)ptrs[i]; gc_t sgc = gc;  gc_t gc = sgc + n;\n\
 \#define gc_frame1(gc,p1) gc[0] = (sptr_t)p1; gc_t sgc = gc;  gc_t gc = sgc + 1;\n\
 \#define gc_frame2(gc,p1,p2) gc[0] = (sptr_t)p1; gc[1] = (sptr_t)p2; gc_t sgc = gc;  gc_t gc = sgc + 2;\n\
 \#endif\n\
 \\n\
 \static unsigned number_gcs;             // number of garbage collections\n\
 \static unsigned number_allocs;          // number of allocations since last garbage collection\n\
 \\n\
 \#define TO_GCPTR(x) (entry_t *)(FROM_SPTR(x))\n\
 \\n\
 \typedef struct {\n\
 \        sptr_t ptrs[0];\n\
 \} entry_t;\n\
 \\n\
 \static const void *nh_start, *nh_end;\n\
 \\n\
 \static bool\n\
 \gc_check_heap(entry_t *s)\n\
 \{\n\
 \        return (s < (entry_t *)nh_start || s > (entry_t *)nh_end);\n\
 \}\n\
 \\n\
 \struct stack {\n\
 \        unsigned size;\n\
 \        unsigned ptr;\n\
 \        entry_t * *stack;\n\
 \};\n\
 \\n\
 \#define EMPTY_STACK { 0, 0, NULL }\n\
 \\n\
 \static void\n\
 \stack_grow(struct stack *s, unsigned grow)\n\
 \{\n\
 \        s->size += grow;\n\
 \        s->stack = realloc(s->stack, sizeof(s->stack[0])*s->size);\n\
 \        assert(s->stack);\n\
 \        debugf(\"stack:\");\n\
 \        for(unsigned i = 0; i < s->ptr; i++) {\n\
 \                debugf(\" %p\", (void *)s->stack[i]);\n\
 \        }\n\
 \        debugf(\"\\n\");\n\
 \}\n\
 \\n\
 \inline static void\n\
 \stack_check(struct stack *s, unsigned n) {\n\
 \        if(__predict_false(s->size - s->ptr < n)) {\n\
 \                stack_grow(s,n + 1024);\n\
 \        }\n\
 \}\n\
 \\n\
 \static struct stack root_stack = EMPTY_STACK;\n\
 \\n\
 \A_UNUSED static void\n\
 \gc_add_root(gc_t gc, sptr_t root)\n\
 \{\n\
 \        if(IS_PTR(root)) {\n\
 \                entry_t *nroot = TO_GCPTR(root);\n\
 \                if(gc_check_heap(nroot)) {\n\
 \                        stack_check(&root_stack,1);\n\
 \                        root_stack.stack[root_stack.ptr++] = nroot;\n\
 \                }\n\
 \        }\n\
 \}\n\
 \\n\
 \static void\n\
 \gc_add_grey(struct stack *stack, entry_t *s)\n\
 \{\n\
 \        VALGRIND_MAKE_MEM_DEFINED(s,S_BLOCK(s)->pi.size * sizeof(uintptr_t));\n\
 \        if(gc_check_heap(s) && s_set_used_bit(s))\n\
 \                stack->stack[stack->ptr++] = s;\n\
 \}\n\
 \\n\
 \static void\n\
 \gc_perform_gc(gc_t gc)\n\
 \{\n\
 \        profile_push(&gc_gc_time);\n\
 \        number_gcs++;\n\
 \\n\
 \        unsigned number_redirects = 0;\n\
 \        unsigned number_stack = 0;\n\
 \        unsigned number_ptr = 0;\n\
 \        struct stack stack = EMPTY_STACK;\n\
 \\n\
 \        clear_used_bits(arena);\n\
 \\n\
 \        debugf(\"Setting Roots:\");\n\
 \        stack_check(&stack, root_stack.ptr);\n\
 \        for(unsigned i = 0; i < root_stack.ptr; i++) {\n\
 \                gc_add_grey(&stack, root_stack.stack[i]);\n\
 \                debugf(\" %p\", root_stack.stack[i]);\n\
 \        }\n\
 \        debugf(\"\\n\");\n\
 \        debugf(\"Trace:\");\n\
 \#ifdef JHC_JGC_STACK\n\
 \        for(;gc;gc = gc->prev) {\n\
 \                debugf(\" |\");\n\
 \                stack_check(&stack, gc->nptrs);\n\
 \                for(unsigned i = 0;i < gc->nptrs; i++) {\n\
 \                        number_stack++;\n\
 \                        // TODO - short circuit redirects on stack\n\
 \                        sptr_t ptr = gc->ptrs[i];\n\
 \                        if(P_LAZY == GET_PTYPE(ptr)) {\n\
 \                                if(!IS_LAZY(GETHEAD(FROM_SPTR(ptr)))) {\n\
 \                                        J1U(r,gc_allocated,((uintptr_t)FROM_SPTR(ptr) - sizeof(entry_t))/GC_ALIGNMENT);\n\
 \                                        if(r)\n\
 \                                                J1S(r,gc_grey,((uintptr_t)FROM_SPTR(ptr) - sizeof(entry_t))/GC_ALIGNMENT);\n\
 \                                        number_redirects++;\n\
 \                                        debugf(\" *\");\n\
 \                                        ptr = (sptr_t)GETHEAD(FROM_SPTR(ptr));\n\
 \                                }\n\
 \                        }\n\
 \                        if(__predict_false(!IS_PTR(ptr))) {\n\
 \                                debugf(\" -\");\n\
 \                                continue;\n\
 \                        }\n\
 \                        number_ptr++;\n\
 \                        entry_t *e = (entry_t *)FROM_SPTR(ptr) - 1;\n\
 \                        debugf(\" %p\",(void *)e);\n\
 \                        gc_add_grey(&gc_grey, &stack, (uintptr_t)e / GC_ALIGNMENT);\n\
 \                }\n\
 \        }\n\
 \#else\n\
 \        stack_check(&stack, gc - gc_stack_base);\n\
 \        number_stack = gc - gc_stack_base;\n\
 \        for(unsigned i = 0; i < number_stack; i++) {\n\
 \                debugf(\" |\");\n\
 \                // TODO - short circuit redirects on stack\n\
 \                sptr_t ptr = gc_stack_base[i];\n\
 \                if(1 && (IS_LAZY(ptr))) {\n\
 \                        assert(GET_PTYPE(ptr) == P_LAZY);\n\
 \                        VALGRIND_MAKE_MEM_DEFINED(FROM_SPTR(ptr), sizeof(uintptr_t));\n\
 \                        if(!IS_LAZY(GETHEAD(FROM_SPTR(ptr)))) {\n\
 \                                void *gptr = TO_GCPTR(ptr);\n\
 \                                if(gc_check_heap(gptr))\n\
 \                                        s_set_used_bit(gptr);\n\
 \                                number_redirects++;\n\
 \                                debugf(\" *\");\n\
 \                                ptr = (sptr_t)GETHEAD(FROM_SPTR(ptr));\n\
 \                        }\n\
 \                }\n\
 \                if(__predict_false(!IS_PTR(ptr))) {\n\
 \                        debugf(\" -\");\n\
 \                        continue;\n\
 \                }\n\
 \                number_ptr++;\n\
 \                entry_t *e = TO_GCPTR(ptr);\n\
 \                debugf(\" %p\",(void *)e);\n\
 \                gc_add_grey(&stack, e);\n\
 \        }\n\
 \#endif\n\
 \        debugf(\"\\n\");\n\
 \\n\
 \        while(stack.ptr) {\n\
 \                entry_t *e = stack.stack[--stack.ptr];\n\
 \                struct s_block *pg = S_BLOCK(e);\n\
 \                VALGRIND_MAKE_MEM_DEFINED(e,pg->pi.size * sizeof(uintptr_t));\n\
 \                debugf(\"Processing Grey: %p\\n\",e);\n\
 \\n\
 \                stack_check(&stack, pg->pi.num_ptrs);\n\
 \                for(int i = 0; i < pg->pi.num_ptrs; i++) {\n\
 \                        if(1 && (P_LAZY == GET_PTYPE(e->ptrs[i]))) {\n\
 \                                VALGRIND_MAKE_MEM_DEFINED(FROM_SPTR(e->ptrs[i]), sizeof(uintptr_t));\n\
 \                                if(!IS_LAZY(GETHEAD(FROM_SPTR(e->ptrs[i])))) {\n\
 \                                        number_redirects++;\n\
 \                                        debugf(\" *\");\n\
 \                                        e->ptrs[i] = (sptr_t)GETHEAD(FROM_SPTR(e->ptrs[i]));\n\
 \                                }\n\
 \                        }\n\
 \                        if(IS_PTR(e->ptrs[i])) {\n\
 \                                entry_t * ptr = TO_GCPTR(e->ptrs[i]);\n\
 \                                debugf(\"Following: %p %p\\n\",e->ptrs[i], ptr);\n\
 \                                gc_add_grey( &stack, ptr);\n\
 \                        }\n\
 \                }\n\
 \        }\n\
 \        free(stack.stack);\n\
 \        s_cleanup_blocks(arena);\n\
 \        if(JHC_STATUS) {\n\
 \#ifdef JHC_JGC_STACK\n\
 \                void * gc_stack_base = &gc_stack_base;\n\
 \                Word_t n_roots;\n\
 \                J1C(n_roots,gc_roots,0,-1);\n\
 \#endif\n\
 \\n\
 \                fprintf(stderr, \"%3u - %6u Used: %4u Thresh: %4u Ss: %5u Ps: %5u Rs: %5u Root: %3u\\n\",\n\
 \                        number_gcs,\n\
 \                        number_allocs,\n\
 \                        (unsigned)arena->block_used,\n\
 \                        block_threshold,\n\
 \                        number_stack,\n\
 \                        number_ptr,\n\
 \                        number_redirects,\n\
 \                        (unsigned)root_stack.ptr\n\
 \                       );\n\
 \                number_allocs = 0;\n\
 \        }\n\
 \        profile_pop(&gc_gc_time);\n\
 \}\n\
 \\n\
 \A_UNUSED static void *\n\
 \(gc_alloc)(gc_t gc,struct s_cache **sc, unsigned count, unsigned nptrs)\n\
 \{\n\
 \        profile_push(&gc_alloc_time);\n\
 \        if (JHC_STATUS)\n\
 \                number_allocs++;\n\
 \        assert(nptrs <= count);\n\
 \        entry_t *e = s_alloc(gc, find_cache(sc, arena, count, nptrs));\n\
 \        VALGRIND_MAKE_MEM_UNDEFINED(e,sizeof(uintptr_t)*count);\n\
 \        debugf(\"allocated: %p %i %i\\n\",(void *)e, count, nptrs);\n\
 \        profile_pop(&gc_alloc_time);\n\
 \        return (void *)e;\n\
 \}\n\
 \\n\
 \static void jhc_alloc_print_stats(void) { }\n\
 \static const void * const nh_stuff[];\n\
 \\n\
 \static void\n\
 \jhc_alloc_init(void) {\n\
 \        VALGRIND_PRINTF(\"Jhc-Valgrind mode active.\\n\");\n\
 \#ifndef JHC_JGC_STACK\n\
 \        saved_gc = gc_stack_base = malloc((1UL << 18)*sizeof(gc_stack_base[0]));\n\
 \#endif\n\
 \        arena = new_arena();\n\
 \        if(nh_stuff[0]) {\n\
 \                nh_end = nh_start = nh_stuff[0];\n\
 \                for(int i = 1; nh_stuff[i]; i++) {\n\
 \                        if(nh_stuff[i] < nh_start)\n\
 \                                nh_start = nh_stuff[i];\n\
 \                        if(nh_stuff[i] > nh_end)\n\
 \                                nh_end = nh_stuff[i];\n\
 \                }\n\
 \        }\n\
 \}\n\
 \\n\
 \static void\n\
 \jhc_alloc_fini(void) {\n\
 \        if(JHC_STATUS) {\n\
 \                fprintf(stderr, \"arena: %p\\n\", arena);\n\
 \                fprintf(stderr, \"  block_used: %i\\n\", arena->block_used);\n\
 \                fprintf(stderr, \"  block_threshold: %i\\n\", arena->block_threshold);\n\
 \                struct s_cache *sc = SLIST_FIRST(&arena->caches);\n\
 \                for(;sc;sc = SLIST_NEXT(sc,next)) {\n\
 \                        print_cache(sc);\n\
 \                }\n\
 \        }\n\
 \}\n\
 \#endif\n\
 \/* src/rts/lib_cbits.c */\n\
 \/* this file contains C only needed to help support the \n\
 \ * standard libraries */\n\
 \\n\
 \static HsInt jhc_stdrnd[2] A_UNUSED = { 1 , 1 };\n\
 \static HsInt jhc_data_unique A_UNUSED;\n\
 \\n\
 \static HsBool A_UNUSED\n\
 \jhc_wait_for_input(FILE *f,HsInt timeout) {\n\
 \#if JHC_isPosix\n\
 \        fd_set fds;\n\
 \        FD_ZERO(&fds);\n\
 \        FD_SET(fileno(f),&fds);\n\
 \        struct timeval to = {  0, timeout * 1000 };\n\
 \        int retval = select(1,&fds,NULL,&fds,&to);\n\
 \        if(retval)\n\
 \                return HS_BOOL_TRUE;\n\
 \        else\n\
 \                return HS_BOOL_FALSE;\n\
 \#else\n\
 \        return HS_BOOL_FALSE;\n\
 \#endif\n\
 \}\n\
 \\n\
 \#ifdef __WIN32__\n\
 \#define getchar_unlocked() getchar()\n\
 \#define putchar_unlocked(x) putchar(x)\n\
 \#define getc_unlocked(x) getc(x)\n\
 \#define putc_unlocked(x,y) putc(x,y)\n\
 \#endif\n\
 \\n\
 \inline static int A_UNUSED\n\
 \jhc_utf8_getchar(void)\n\
 \{\n\
 \    return getchar_unlocked();\n\
 \}\n\
 \\n\
 \inline static int A_UNUSED\n\
 \jhc_utf8_getc(FILE *f)\n\
 \{\n\
 \    return getc_unlocked(f);\n\
 \}\n\
 \\n\
 \inline static int A_UNUSED\n\
 \jhc_utf8_putchar(int ch)\n\
 \{\n\
 \    return putchar_unlocked(ch);\n\
 \}\n\
 \\n\
 \inline static int A_UNUSED\n\
 \jhc_utf8_putc(int ch, FILE *f)\n\
 \{\n\
 \    return putc_unlocked(ch,f);\n\
 \}\n\
 \#endif\n\
 \"#



